

theory Random10
imports RandomPolicies
begin


declare [[testgen_profiling]]


lemma ail7: "all_in_list (policy2list (Policy10)) (Nets_List Policy10)"
apply (unfold Nets_List_def bothNets_def)
apply (insert nets_different, simp add: aux aux2 Policy10_def)
done

definition P10 where "P10 = Policy10"




test_spec 
 "FUT x = (C Policy10) x"
apply (prepare_fw_spec)
apply (rule_tac PL = "((Comb2PolList (rev (normalize (Policy10))) C))" 
   in distrPUTLG1)
apply (simp add: Policy10_def domDA1)
apply (rule fun_cong) back
apply (rule NormalisationIntegerPortProof.p_eq2)
apply (rule NormalisationIntegerPortProof.norm_notMT)
apply (simp add: Policy10_def)
apply (rule NormalisationIntegerPortProof.C_eq_normalize)
apply (simp add: Policy10_def)
apply (rule aND10)
apply (rule ail7) 
apply (simp only: normalize_def)
apply (subst P10_def[symmetric])
apply (insert noMT210 nets_different, simp add: Nets_List_def bothNets_def
                         aux aux2 Policy10_def)
apply (simp add: P10_def aux aux2 Policy10_def, thin_tac "?X",thin_tac "?S")
apply (simp add: PUTListGD_def)
apply (simp add: gatherDomain_def domain_reasoning dom_2 domDA1)
apply (tactic  
 "REPEAT(CHANGED(TRYALL((rtac @{thm conjI}) THEN' (rtac @{thm impI}))))")
apply (simp_all add: PLemmas UnfoldPolicy)
apply (gen_test_cases FUT)
store_test_thm "Policy10"

declare UnfoldPolicy[simp]
declare PLemmas[simp]

gen_test_data Policy10

declare UnfoldPolicy[simp del]
declare PLemmas[simp del]   

export_fw_data "Random.data" Policy10
write_clocks "Random10.tex"

end

