#!/bin/bash

export WD=`pwd`
#timing=15000

declare -a examples 
examples=('Normalized1 1000' 'Normalized2 1000' 'Normalized3 1000' 'Normalized4 1000' 'Normalized6 2000' 'Normalized7 1000' 'Normalized8 500' 'Normalized9 2000' 'Normalized10 500'  'Normalized5 70000')
element_count=${#examples[@]}
index=0

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $2}'`
  #  t=`echo ${examples[$index]} | awk '{print $timing}'`
  #  t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`"
    echo "* time limit: $t"
    cd $dir;
    ulimit -S -t $t
   isabelle env ISABELLE_OUTPUT=../heaps make -f IsaMakefile -B;
    echo "* Finished $dir successfully on `date`"
    echo "***************************************************************************"
    echo 
    cd $WD;
    let "index = $index + 1"
done



