

theory RandomQuick2
imports RandomPolicies
begin


declare [[testgen_profiling]]


lemma ail7: "all_in_list (policy2list (Policy2)) (Nets_List Policy2)"
apply (unfold Nets_List_def bothNets_def)
apply (insert nets_different, simp add: aux aux2 Policy2_def)
done

definition P10 where "P10 = Policy2"




test_spec 
 "FUT x = (C Policy2) x"
apply (prepare_fw_spec)
apply (rule_tac PL = "((map C (rev (normalizeQ (Policy2)))))" 
   in distrPUTLG1)
apply (simp add: Policy2_def domDA1)
apply (rule fun_cong) back
apply (rule NormalisationIntegerPortProof.p_eq2Q)
apply (rule NormalisationIntegerPortProof.norm_notMTQ)
apply (simp add: Policy2_def)
apply (rule NormalisationIntegerPortProof.C_eq_normalizeQ)
apply (simp add: Policy2_def)
apply (rule aND2)
apply (rule ail7) 
apply (simp only: normalizeQ_def)
apply (subst P10_def[symmetric])
apply (insert noMT22 nets_different, simp add: Nets_List_def bothNets_def
                         aux aux2 Policy2_def)
apply (simp add: P10_def aux aux2 Policy2_def, thin_tac "?X",thin_tac "?S")
apply (simp add: PUTListGD_def)
apply (simp add: gatherDomain_def domain_reasoning dom_2 domDA1)
apply (tactic  
 "REPEAT(CHANGED(TRYALL((rtac @{thm conjI}) THEN' (rtac @{thm impI}))))")
apply (simp_all add: PLemmas UnfoldPolicy)
apply (gen_test_cases FUT)
store_test_thm "Policy2"

declare UnfoldPolicy[simp]
declare PLemmas[simp]

gen_test_data Policy2

declare UnfoldPolicy[simp del]
declare PLemmas[simp del]   

export_fw_data "RandomQuick.data" Policy2
write_clocks "RandomQuick2.tex"

end

