#!/bin/bash

export WD=`pwd`
timing=50000


declare -a examples 
examples=('Random1 $timing' 'RandomQuick1 $timing'  'Random2 $timing' 'RandomQuick2 $timing' 'Random3 $timing' 'RandomQuick3 $timing' 'Random4 $timing' 'RandomQuick4 $timing' 'Random5 $timing' 'RandomQuick5 $timing' 'Random6 $timing' 'RandomQuick6 $timing' 'Random7 $timing' 'RandomQuick7 $timing' 'Random8 $timing' 'RandomQuick8 $timing' 'Random9 $timing' 'RandomQuick9 $timing' 'Random10 $timing' 'RandomQuick10 $timing' 'Random11 $timing' 'RandomQuick11 $timing' 'Random12 $timing' 'RandomQuick12 $timing')
element_count=${#examples[@]}
index=0

echo "foo "

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $timing}'`
    t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`" 
    echo "* time limit: $t"
    cd $dir;
#    ulimit -S -t $t
    isabelle env ISABELLE_OUTPUT=../heaps make -f IsaMakefile -B;
    echo "* Finished $dir successfully on `date`" >> ../time.log
    echo "***************************************************************************" 
    echo 
    cd $WD;
    let "index = $index + 1"
done

zgrep -hEo "^.+test cases in.+$" heaps/log/*.gz > RandomLogs.tex
