#!/bin/bash

export WD=`pwd`
timing=36000


declare -a examples 
examples=('fw_networks $timing')
element_count=${#examples[@]}
index=0

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $timing}'`
    t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`"
    echo "* time limit: $t"
#    ulimit -S -t $t
    ~/Isabelle2011-1/bin/isabelle env ISABELLE_OUTPUT=heap make -f IsaMakefile;
    echo "* Finished 1 successfully on `date`"
    zgrep -Eo "^.+test cases in.+$" heap/log/* > networks.tex
    echo "* Finished $dir successfully on `date`"
    echo "***************************************************************************"
    echo 
    cd $WD;
    let "index = $index + 1"
done



